Partial Class AltTable
Inherits System.Web.UI.UserControl

public TblName as string
public TblAlias as string
public Delim as string = ","
public altFields as New ArrayList()

Public Property FieldList() As String
  Get
    dim i as Integer
    dim result as String=""
    for i=0 to altFields.Count-1
      if i > 0 then result &= Delim
      result &= altFields(i).ColName
    next
    Return result
  End Get
  Set(ByVal Value As String)
    dim i as Integer
    dim arFields=Value.split(Delim)
    for i=0 to ubound(arFields)
      if i = altFields.Count then altFields.Add(New AltColumnClass())
      altFields(i).ColName=arFields(i)
    next
  End Set
End Property

Public Property FieldData() As String
  Get
    dim i as Integer
    dim result as String=""
    for i=0 to altFields.Count-1
      if i > 0 then result &= Delim
      result &= altFields(i).Data
    next
    Return result
  End Get
  Set(ByVal Value As String)
    dim i as Integer
    dim arData=Value.split(Delim)
    for i=0 to ubound(arData)
      if IsNothing(altFields(i)) then altFields(i)=New AltColumnClass()
      altFields(i).Data=arData(i)
    next
  End Set
End Property


Public Function FieldCondition(FieldIdx as Integer, optional WithAlias as Boolean=true) As String
  dim s as String = altFields(FieldIdx).ColName & "=" & altFields(FieldIdx).Data
  if WithAlias then s = TblAlias & "." & s
  FieldCondition=s
End Function


Public Function KeyCondition(optional WithAlias as Boolean=false) As String
  dim i as Integer
  dim k as String = ""
  for i=0 to altFields.Count-1
    if altFields(i).isKey then
      k &= " AND (" & FieldCondition(i,WithAlias) & ")"
    end if
  next
  KeyCondition=k
End Function


Public Class AltColumnClass
  public ColName as string
  public Data as string
  public isKey as boolean
End Class


End Class
